<?php
/**
 * This plugin utilizes Open Source code. Details of these open source projects along with their licenses can be found below.
 * We acknowledge and are grateful to these developers for their contributions to open source.
 *
 * Project: mobile-dj-manager https://github.com/deckbooks/mobile-dj-manager
 * License: (GNU General Public License v2.0) https://github.com/deckbooks/mobile-dj-manager/blob/master/license.txt
 *
 * @author: Mike Howard, Jack Mawhinney, Dan Porter
 *
 * Contains all admin availability related functions
 *
 * @package     TMEM
 * @subpackage  Availability
 */

// Exit if accessed directly.
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

/**
 * Performs an employee availability check.
 *
 * @since   1.5.6
 * @param   array $data   $_POST data.
 * @return  void
 */
function tmem_employee_availability_check_action( $data ) {
	if ( ! isset( $data['tmem_nonce'] ) || ! wp_verify_nonce( $data['tmem_nonce'], 'employee_availability_check' ) ) {
		wp_die( esc_html__( 'Security failure', 'mobile-events-manager' ) );
	}

	if ( ! empty( $data['check_date'] ) ) {

	}

	$return_url = add_query_arg(
		array(
			'post_type'    => 'tmem-event',
			'page'         => 'tmem-availability',
			'tmem-message' => $message,
		),
		admin_url( 'edit.php' )
	);

	wp_safe_redirect( $return_url );
	exit;
} // tmem_employee_availability_check_action
add_action( 'tmem_employee_availability_lookup', 'tmem_employee_availability_check_action' );
